/**********************************************************************
 *
 *       *** HAPPy Pascal Compiler ***
 *               P-code assmebler
 *
 *           Copyright (c) H.Asano 1992-1994.
 *
 **********************************************************************/

#define EXTERN extern
#define Maxlabel   500                  /* ő僉x               */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "version.h"
#include "hapai.h"

/********* co-operation table **********/
static char cop[] = {
    115/*lod*/, 105/*ldo*/, 125/*str*/, 120/*sro*/,
    130/*sto*/, 110/*chk*/, 135/*ind*/ } ;

/***************************************/
/*            x\                 */
/***************************************/
enum lbst {  entered,                   /* xo^̏         */
             defined                    /* x`ς̏         */
          };

static struct  {
  short     val         ;               /* value                      */
  enum lbst st          ;               /* status {enterd,defined}    */
} labeltab[Maxlabel]    ;

/***************************************/
/*      zvZ@ Lu            */
/***************************************/
static _store store[Maxstore] ;

/***************************************/
/*            ϐ`                 */
/***************************************/
static char *PcodeSourceName ;          /* P-codȩٖ@@@@@@*/
static char *PcodeObjectName ;          /* P-code޼ު̧ٖ       */
static char *CompVersion     ;          /* RpC̃o[W     */
static FILE *pcsfile         ;          /* P-codȩ߲         */
static FILE *objfile         ;          /* P-code޼ު̧߲    */
static short codesize        ;          /* R[hܰ޻           */
static short objsize         ;          /* IuWFNgŜܰ޻ */
static short ch              ;          /* Ǎ                   */
static short intch           ;          /* Ǎł̓Ǎ     */
static short  pc             ;          /* program counter            */
static _code  cd             ;          /* P-code                     */
static short entpc           ;          /* ent߂̔Ԓn              */
static short start = -1      ;          /* IuWFNgJn̍}     */

/*********************************************************************/

/***************************************/
/*     G[bZ[Wo͏        */
/***************************************/
static void paerr(short errno)
{
  static struct _errmsg {
       short msgno       ;              /* error message number       */
       char  *errmsg     ;              /* error message              */
     } errtb[]  =  {

   {1,  "ߐ"},
   {2,  "IuWFNgt@CI[vłȂ"},
   {3,  "IuWFNgt@Co͂ŃG["},
   {4,  "x"},
   {5,  "萔"},
   {6,  "P-code\[Xt@CI[vłȂ"},
   {7,  "PC.EXEPA.OVL̃o[WႤ"},
   {8,  "AZuXg̏o͂ŃG["}
} ;
  short i = -1 ;

     while(errtb[++i].msgno != errno) ; /* search message             */
     fprintf(stderr,"A%03d: %s\n", errno, errtb[i].errmsg);
     exit(3) ;                          /* AZuG[Œ~     */
}

/***************************************/
/*      reset() : reset֐            */
/***************************************/
static void reset(char *filename)
{

     pcsfile = fopen(filename,"r") ;
     if(pcsfile == NULL) paerr(6) ;

     intch =  getc(pcsfile)  ;          /* 1ǂ                */
}

/***************************************/
/*       eoln() : eoln}N`       */
/***************************************/
#define eoln()   (intch == '\n')        /* sǂłΐ^       */

/***************************************/
/* readc() : char^read            */
/***************************************/
static short readc(void)
{
  short oldch ;

     oldch    = intch         ;
     intch    = getc(pcsfile) ;
     return(oldch)      ;
}

/***************************************/
/*   readi() : integer^͏       */
/***************************************/
static integer readi(void)
{
  integer  ival = 0 ;
  short    sign = 1 ;

     if(intch == ' ')
      while((intch = getc(pcsfile)) == ' '); /* 󔒓ǂݔ΂        */

     if(intch=='-') {                    /* ̎ ( + ͌Ȃ)  */
      sign = -1              ;           /* ɉ          */
      intch  = getc(pcsfile) ;           /* ǂݔ΂          */
     }

     do {
      ival = ival*10 + intch-'0' ;
      intch=getc(pcsfile) ;
     } while(('0' <= intch) && (intch <= '9')) ;

     return(sign*ival) ;
}

/***************************************/
/*   readr() : real^͏          */
/***************************************/
static float readr(void)
{
  char   buf[20] ;
  short  i = 0   ;

     while(intch == ' ') intch = getc(pcsfile) ;   /* 󔒓ǂݔ΂ */
     do {
      buf[i++] = (char)intch ;
      intch = getc(pcsfile) ;
     } while (intch != '\n') ;
     buf[i] = '\0' ;

     return((float)atof(buf)) ;         /* _֕ϊ           */
}

/***************************************/
/* readln() : EOL܂œǂݔ΂    */
/***************************************/
static void readln(void)
{
     while(!eoln()) intch = getc(pcsfile) ;
     intch = getc(pcsfile);
}

/***************************************/
/*    IuWFNgt@Co     */
/***************************************/
static void putobject(char *area, short size)
{
      fwrite(area,size,1,objfile) ;
      if(ferror(objfile)) paerr(3) ;    /* ݎs               */
}

/***************************************/
/*          ݒ菈               */
/***************************************/
static void init(void)
{
  short i;

     for(i=0;i<Maxlabel;i++) {          /* x\  ݒ       */
      labeltab[i].val = -1 ;
      labeltab[i].st  = entered;
     }

     reset(PcodeSourceName) ;           /* P-codȩق̵       */

     objfile = fopen(PcodeObjectName,"wb") ;/* t@CI[v       */
     if(objfile == NULL) paerr(2) ;     /* I[vłȂ           */

     if(codesize > Maxstore)            /* Lȗ傫傫*/
      paerr(1) ;                        /* ۸ђ~                */

     if(strcmp(CompVersion,version))
      paerr(7) ;                        /* o[Wsv           */

     putobject(version,strlen(version)+1) ; /* o[Wԍo     */

     objsize = codesize ;
}

/***************************************/
/*    x\o^                 */
/***************************************/
static void update(void)
{
   short x         ;                    /*  x: label                */
   short curr,succ ;

     x=(short)readi()           ;       /* xǂ             */
     if(x >= Maxlabel) paerr(4) ;       /* x         */

     if(labeltab[x].val != -1) {        /* OQƂĂ鎞       */
      curr = labeltab[x].val;
      do {
       succ = store[curr].vo.q;
       store[curr].vo.q = pc  ;
       curr = succ ;
      } while(succ != -1) ;
     }
     labeltab[x].st  = defined    ;
     labeltab[x].val = pc         ;
}

/***************************************/
/*     xlǍ                */
/***************************************/
static void labelsearch(void)
{
  short x ;

     while(ch != 'L') ch = readc() ;    /* 'L' ܂ ǂݔ΂        */
     x = (short)readi() ;
     if(x >= Maxlabel) paerr(4) ;       /* x         */
     if(labeltab[x].st == entered) {    /* `                     */
      cd.q = labeltab[x].val  ;         /* l̂܂܁@-1           */
      labeltab[x].val = pc    ;         /* pci[               */
     }
     else cd.q = labeltab[x].val ;      /* `ς̎                 */
}


/********* typesymbol() : instruction4ڂɂop肷 *********/
static void typesymbol(void)
{
   short i;

     switch(ch) {
      case 'i' : return ;       /* 'i' ̎ op͂̂܂ */
      case 'a' : i=0; break;
      case 'r' : i=1; break;
      case 's' : i=2; break;
      case 'b' : i=3; break;
      case 'c' : i=4;
     }
     cd.op=cop[cd.op]+i;             /* op̕ύX */
}

/**************************************/
/* PTN0() : IyĥȂ      */
/**************************************/
static void PTN0(void)
{
}

/**************************************/
/* PTN1() : lod,str̃AZu       */
/**************************************/
static void PTN1(void)
{
     typesymbol() ;
     cd.p=(char)readi() ;
     cd.q=(short)readi() ;
}

/**************************************/
/* PTN2() : lda,mov,wrs̃AZu   */
/**************************************/
static void PTN2(void)
{
     cd.p=(char)readi() ;
     cd.q=(short)readi() ;
}

/*********************************************/
/* PTN3() : mst,cui,bas,tra.mms,             */
/*          eol,eof,pge,rln,rdc,rdi,rdr,tgt, */
/*          tgt,tpt,trs,trw,wln,wrb,wrc,wrf, */
/*          wri,wrr ̃AZu             */
/*********************************************/
static void PTN3(void)
{
     cd.p=(char)readi() ;
}

/**************************************/
/* PTN4() : cup,ejp̃AZu       */
/**************************************/
static void PTN4(void)
{
     cd.p=(char)readi() ;
     labelsearch();
}

/************************************************/
/* PTN5() : equ,neq,geq,grt,leq,les̃AZu */
/************************************************/
static void PTN5(void)
{
     switch(ch) {
    /*case 'a' :     ; break ;   Ȃ */
      case 'i' : cd.p=1 ; break ;
      case 'r' : cd.p=2 ; break ;
      case 'b' : cd.p=3 ; break ;
      case 's' : cd.p=4 ; break ;
      case 'c' : cd.p=6 ; break ;
      case 'm' : cd.p=5 ;
                 cd.q=(short)readi() ;
     }
}

/**************************************/
/* PTN6() : ldo,sro,ind̃AZu   */
/**************************************/
static void PTN6(void)
{
     typesymbol() ;
     cd.q=(short)readi();
}

/****************************************/
/* PTN7() : inc,dec,nxt,nxd̃AZu */
/****************************************/
static void PTN7(void)
{
     switch(ch) {
    /*case 'a' :  cd.p=0;    break ;  Ȃ */ /* inc,deĉ */
      case 'i' :  cd.p=1;    break ;
      case 'b' :  cd.p=3;    break ;
      case 'c' :  cd.p=6;    break ;
     }
     cd.q = (short)readi() ;
}

/****************************************/
/* PTN8() : ujp,fjp,lap̃AZu     */
/****************************************/
#define PTN8  labelsearch

/***************************************/
/* PTN9() : lao,new,dis̃AZu    */
/***************************************/
static void PTN9(void)
{
     cd.q=(short)readi();
}

/**************************************/
/* ENT() : ent̃AZu            */
/**************************************/
static void ENT(void)
{
     entpc = pc ;
}

/**************************************/
/* CHK() : chk̃AZu            */
/**************************************/
static void CHK(void)
{
   integer  lb,ub ;

     typesymbol() ;
     cd.p = (char)readi() ;             /* `FbNʁ@             */
     lb = readi();                      /* l                     */
     ub = readi();                      /* l                     */
     if(objsize+1>=Maxstore) paerr(5) ; /* 萔i[s               */
     store[objsize  ].vi = lb ;
     store[objsize+1].vi = ub ;
     cd.q=codesize;
     do {
      cd.q++ ;
     } while((store[cd.q-1].vi != lb) || (store[cd.q].vi != ub)) ;
     if(cd.q   == objsize) objsize++   ;/* Ō1萔ǉ̎  */
     if(cd.q-1 == objsize) objsize += 2;/* Ō2  ΐǉ̎  */
}

/**************************************/
/* IXA() : ixãAZu            */
/**************************************/
static void IXA(void)
{
  integer low  ;
  short   ixav ;

     low  = readi() ;                     /* l                     */
     ixav = (short)readi() ;              /* ixal                      */
     if(objsize+1>=Maxstore) paerr(5) ;   /* 萔i[s               */
     store[objsize  ].vi = low  ;
     store[objsize+1].va = ixav ;         /*  2oCgGAgp       */
     cd.q=codesize;
     do {
      cd.q++ ;
     } while((store[cd.q-1].vi != low) || (store[cd.q].va != ixav)) ;
     if(cd.q   == objsize) objsize++   ;/* Ō1萔ǉ̎  */
     if(cd.q-1 == objsize) objsize += 2;/* Ō2  ΐǉ̎  */
}

/**************************************/
/* LCA() : lcãAZu            */
/**************************************/
/* lca ''\n Ƃ`ƂBŌオsŏIBŏ ' 
  s̑O '  P-code\[XǂސlԂɂ킩₷悤ɂĂ邾 */

static void LCA(void)
{
     cd.q=objsize;
     readc() ;                          /* ŏ ' ǂݔ΂      */
     while(!eoln()) {                   /* s܂ł̕i[     */
      if(objsize+1>=Maxstore) paerr(5); /* 萔i[s               */
      store[objsize++].vc = readc() ;
     }
     objsize-- ;                        /* Ō ' ̂Ă          */
}

/**************************************/
/*   checkConst() : 萔i[`FbN  */
/**************************************/
static void checkConst(void)
{
     if(cd.q==objsize) {
      if(objsize+1>=Maxstore) paerr(5); /* 萔i[s               */
      objsize++ ;
     }
}

/**************************************/
/* LDC() : ldc̃AZu            */
/**************************************/
static void LDC(void)
{
  integer inumber ;
  float   rnumber ;
  long    s       ;

     switch(ch) {
      case 'i' : cd.p=1 ;               /* integer type               */
                 inumber = readi() ;
                 if(labs(inumber) < (long)Largeint)
                  cd.q = (short)inumber;
                 else {                 /* 傫Ȑ̎               */
                  cd.op = 66 ;          /* lci߂ɕύX              */
                  store[objsize].vi = inumber ;
                  cd.q = codesize ;
                  while(store[cd.q].vi != inumber) cd.q++ ;
                  checkConst() ;        /* 萔i[`FbN           */
                 }
                 break ;

      case 'c' : cd.p=6 ;               /* char type                  */
                 while(readc() != '\'');/*  ŏ '        */
                 cd.q=readc() ;         /*  ǂݍ            */
                 break ;                /*  Ō ' ͖       */

      case 'b' : cd.p=3;                /* boolean                    */
                 cd.q=(short)readi() ;
                 break;

      case 's' : cd.p = 4;              /* set type                   */
                 s=0;
                 while(readc() != '(') ;
                 while(readc() != ')') addset(s,(short)readi())  ;
                 store[objsize].vs = s ;
                 cd.q = codesize ;
                 while(store[cd.q].vs != s) cd.q++ ;
                 checkConst() ;         /* 萔i[`FbN           */
                 break ;

      case 'r' : cd.p = 2 ;
                 rnumber = readr() ;
                 store[objsize].vr = rnumber ;
                 inumber = store[objsize].vi ;
                 /* _̌`ŔrsƎvʗƂ̂
                   rbg̔r邽߂ɁAunion^vi琔𓾂*/
                 cd.q = codesize ;
                 while(store[cd.q].vi != inumber) cd.q++ ;
                 checkConst() ;         /* 萔i[`FbN           */
                 break ;

    /*case 'n' : cd.p=0 ; */            /* ldc nil                    */
              /* cd.q=0 ; */
     }
}

/**************************************/
/* ORD() : ord̃AZu            */
/**************************************/
static void ORD(void)
{
     switch(ch) {
      case 'b' : cd.p=3 ; break ;
      case 'c' : cd.p=6 ;
     }
}

/**************************************/
/* RET() : ret̃AZu            */
/**************************************/
static void RET(void)
{
     switch(ch) {
    /*case 'p' :     ; break ;  Ȃ */
      case 'i' : cd.p=1 ; break ;
      case 'r' : cd.p=2 ; break ;
      case 'c' : cd.p=3 ; break ;
      case 'b' : cd.p=4 ; break ;
      case 'a' : cd.p=5 ; break ;
     }
}

/**************************************/
/* STO() : stõAZu            */
/**************************************/
#define STO  typesymbol

/**********************************************************************/
/*                   P-code j[jbN\                            */
/**********************************************************************/
static char instr[][4] =
{
   /*          x0    x1    x2    x3    x4    x5    x6    x7    x8    x9  */
   /* 0x */  "lod","ldo","str","sro","sto","chk","ind","ldc","lda","dec",
   /* 1x */  "inc","mst","cup","ent","ret","...","ixa","equ","neq","geq",
   /* 2x */  "grt","leq","les","ujp","fjp","xjp","ejp","lap","adi","adr",
   /* 3x */  "sbi","sbr","sgs","flt","flo","trc","ngi","ngr","sqi","sqr",
   /* 4x */  "abi","abr","not","and","ior","dif","int","uni","inn","mod",
   /* 5x */  "odd","mpi","mpr","dvi","dvr","mov","lca","lao","stp","ord",
   /* 6x */  "chr","ujc","mms","msi","cui","bas","...","cka","tra","rou",
   /* 7x */  "nxt","nxd","...","...","...","new","dis","pge","eof","eol",
   /* 8x */  "rst","rwt","get","put","wrs","wrb","wri","wrr","wrc","wrf",
   /* 9x */  "wln","rdi","rdr","rdc","rln","trs","trw","tgt","tpt","atn",
   /*10x */  "sin","cos","exp","log","sqt"
} ;

/******* j[jbNΉ̃Gg\ ********/
static struct entry {
       void (*func)(void) ;
} OP[] = {
   /*          x0    x1    x2    x3    x4    x5    x6    x7    x8    x9  */
   /* 0x */   PTN1, PTN6 ,PTN1, PTN6, STO , CHK , PTN6, LDC , PTN2, PTN7,
   /* 1x */   PTN7, PTN3, PTN4, ENT , RET , PTN0, IXA , PTN5, PTN5, PTN5,
   /* 2x */   PTN5, PTN5, PTN5, PTN8, PTN8, PTN0, PTN4, PTN8, PTN0, PTN0,
   /* 3x */   PTN0, PTN0, PTN0, PTN0, PTN0, PTN0, PTN0, PTN0, PTN0, PTN0,
   /* 4x */   PTN0, PTN0, PTN0, PTN0, PTN0, PTN0, PTN0, PTN0, PTN0, PTN0,
   /* 5x */   PTN0, PTN0, PTN0, PTN0, PTN0, PTN2, LCA , PTN9, PTN0, ORD ,
   /* 6x */   PTN0, PTN0, PTN3, PTN0, PTN3, PTN3, PTN0, PTN0, PTN3, PTN0,
   /* 7x */   PTN7, PTN7, PTN0, PTN0, PTN0, PTN9, PTN9, PTN3, PTN3, PTN3,
   /* 8x */   PTN0, PTN0, PTN0, PTN0, PTN2, PTN3, PTN3, PTN3, PTN3, PTN3,
   /* 9x */   PTN3, PTN3, PTN3, PTN3, PTN3, PTN3, PTN3, PTN3, PTN3, PTN0,
   /*10x */   PTN0, PTN0, PTN0, PTN0, PTN0
} ;

/***************************************/
/*     1sAZu               */
/***************************************/
static void assemble(void)
{
   char name[4];

     *name     = (char)readc()  ;       /* 1 */
     *(name+1) = (char)readc()  ;       /* 2 */
     *(name+2) = (char)readc()  ;       /* 3 */
     *(name+3) = '\0'     ;
     if(!eoln()) ch=readc();
      /* ōsIĂȂΎ̕ǂ */

     cd.op = -1 ;
     while(strcmp(instr[++cd.op],name)) ;/* instructionop   */
         /* ̂悤ȃjAT[`̓Xs[hx̂ŉǂ悤      */

     cd.p   =  0 ;
     cd.q   =  0 ;
     OP[cd.op].func() ;                 /* opɑΉAZu     */

     store[pc++].vo = cd ;              /* Ɋi[               */
}

/********** generate() :  s̍ŏɌĂ΂鏈 **********/
static void generate(void)
{
   short i     ;                        /* ƃJE^               */
   char progname[33] ;                  /* vO               */
   char filename[33] ;                  /* t@C                 */
   short fileadr       ;                /* t@CAgX           */
   short filesize      ;                /* obt@ϐ̑傫       */

     for(;;) {
      ch=readc();                       /* s̍ŏ̕ǂ       */
      switch(ch) {
       case ' ' : assemble();           /* ʏ햽 ̍sAZu*/
                  break     ;
 
       case ';' :                       /* ߍs𖳎               */
                  break ;
 
       case 'L' : update()  ;           /* labelo^                  */
                  break ;
 
       case 'V' : store[entpc].vo.p = (unsigned char)readi() ;
                  store[entpc].vo.q = (short)        readi() ;
                  break ;
 
       case 'F' :                       /* t@CAhX           */
                  readc() ;             /* 󔒂ǂݔ΂           */
                  i=0 ;
                  while((ch=readc()) != ' ') /* t@C擾        */
                   filename[i++] = (char)ch ;
                  filename[i++] = '\0'  ;
                  readc() ;                       /*  󔒂ǂݔ΂*/
                  fileadr = (short)readi() ;      /* t@CAgX */
                  putobject((char*)&fileadr,sizeof(fileadr));/* o  */
                  filesize = (short)readi();      /* obt@TCY   */
                  putobject((char*)&filesize,sizeof(filesize));/* o*/
                  putobject(filename,i) ;         /* t@Co   */
                  break ;

       case 'N' :                       /* vO               */
                  readc() ;             /* 󔒂ǂݔ΂           */
                  i=0 ;
                  while(!eoln())        /* vO擾           */
                   progname[i++] = (char)readc() ;
                  progname[i++] = '\0' ;
                  putobject(progname,i);/* o                       */
                  break ;

       case 'Q' : return ;              /* AZuI           */
      }
      readln() ;                        /* s̎cǂݔ΂       */
     }
}


/*****************************************/
/* assemblelist() : AZuXgo */
/*****************************************/
static void assemblelist(void)
{
     reset(PcodeSourceName) ;           /* P-codȩق̵       */

     printf("\n ADDR   OP   P      Q    P-code source statement\n");
     printf(  "================================================\n");

     pc  = 0 ;

     for(;;) {
      ch=readc();                       /* s̍ŏ̕             */
      switch(ch) {
       case ' ' :  printf(" %4d: %3d %3d %6d    %c",
                     pc++, store[pc].vo.op, store[pc].vo.p ,
                     store[pc].vo.q,ch);
                   break;
       case ';' :
       case 'L' :
       case 'V' :
       case 'F' :
       case 'N' :  printf("\t\t\t %c",ch) ;
                   break;
       case 'Q' :  printf("\t\t\t Q\n") ;
                   if(codesize != objsize)
                   printf(" %4d:\n   `: constant data\n %4d:\n",
                     codesize,objsize-1) ;
                   fclose(pcsfile) ;   /* \[Xt@C̃N[Y   */
                   return;
      }
      while(!eoln()) putc(readc(),stdout) ;
      printf("\n") ;
      if(ferror(stdout)) paerr(8) ;     /* o͂ŃG[     */
      readln()     ;
     }
}

/***************************************/
/* main() : P-codeAZuC */
/***************************************/
short main(short argc,char *argv[])
{
     codesize  = atoi(argv[1]) ;        /* ߃R[h̐             */
     PcodeSourceName = argv[2] ;        /* P-code\[Xt@C     */
     PcodeObjectName = argv[3] ;        /* P-codeIuWFNgt@C*/
     CompVersion     = argv[4] ;        /* RpC̃o[W     */
     init();                            /* e평ݒ               */
     generate();                        /* AZu                 */
     fclose(pcsfile)  ;                 /* \[Xt@C̃N[Y   */

     for(pc=0;pc<codesize;pc++) {       /* qނ̕␳         */
      cd.op = store[pc].vo.op ;
      if((/*lao*/ cd.op==57)||(/*ldox*/cd.op==1 || (105<=cd.op && cd.op<=109))
                            ||(/*srox*/cd.op==3 || (120<=cd.op && cd.op<=124)))
       store[pc].vo.q += objsize ;
     }

     putobject((char*)&start,sizeof(start)) ; /* IuWFNgJn} */
     putobject((char*)store,objsize*sizeof(_store)) ; /* IuWFNgo*/
     if(fflush(objfile) == EOF) paerr(3) ;
     if(fclose(objfile) == EOF) paerr(3) ;
                 /* N[YłȂΏݎs̉\    */

     fputs(         " *** Assemble completed. ***\n",stderr);
     fprintf(stderr," *** code = %5d words  constant data = %5d words ***\n",
                                codesize,       objsize-codesize);

     if(argc==6) assemblelist();        /* AZuXg̏o     */

     return(0) ;                        /* I                   */
}
